//         Install ALL Scripts as plug-in 
//                         by
//  B.Schaffer (FELMI/ZFE) & D. R. G. Mitchell (ANSTO Materials)
//

// Define the necessary variables
string base,menu,submenu,item,packageNAME,name
number maxitem,i,j,maxfolder
taggroup tgFILES,tgFOLDERS,tg

// Just some starting text in the results window.
result("\n Automatic Installation of all scripts in a folder as Plugin:\n\n")

// First get the default folder. (In this case, the folder last opened within DM)
base = GetApplicationDirectory(2,0)

// Prompt the user with a dialog to choose a folder, with the default folder as first choice. 
// If the user cancels the dialog, the script will stop.
If (!GetDirectoryDialog("Please select the folder containing the scripts",base,base)) exit(0)

// Ask the user for a package name
If (!GetString("Name of package file?","",packageNAME)) exit(0)

// Ask the user for a menu name
If (!GetString("Name of menu to install the scripts in","",menu)) exit(0)

// Get all files/folders in the folder as a tag-list
tgFILES   = GetFilesInDirectory(base,1)
tgFOLDERS = GetFilesInDirectory(base,2)

// Install all files from the main folder as menu commands.
// Count Items in the folder
maxitem = tgFILES.TagGroupCountTags()
i = 0

// Loop through all items
while (i<maxitem)
	{
	// get taggroup of item
	tgFiles.TagGroupGetIndexedTagAsTagGroup(i,tg)

	// get name of file
	tg.TagGroupGetTagAsString("Name",item)
	
	// Only if filename end with ".s" continue
	If (right(item,2)==".s")
		{
		// use the name without the ending
		name = left(item,len(item)-2)	
		result("\n Installing: "+item)

		// install the menu command
		// use the Try-Catch loop to detect problems during install
		try 
			{
			AddScriptToPackage(base+item,packageNAME,0,name,menu,"", 0)
			}
		catch
			{
			result(" \t ERROR DURING INSTALL")
			}
		}
	i++
	}

// Now install all files from sub-folder as sub-menu commands.
// Count subfolders in the folder
maxfolder = tgFOLDERS.TagGroupCountTags()


// Loop for all subfolders
for (j=0;j<maxfolder;j++)
	{	
	// get taggroup of item
	tgFolders.TagGroupGetIndexedTagAsTagGroup(j,tg)

	// get name of subfolder which is also the name of the submenu
	tg.TagGroupGetTagAsString("Name",submenu)

	// Get all files in the subfolder as a tag-list
	tgFILES   = GetFilesInDirectory(base+submenu,1)

	// Count Items in the folder
	maxitem = tgFILES.TagGroupCountTags()
	i = 0

	// Loop through all items as before for the main folder
	while (i<maxitem)
		{
		tgFiles.TagGroupGetIndexedTagAsTagGroup(i,tg)
		tg.TagGroupGetTagAsString("Name",item)	
		If (right(item,2)==".s")
			{
			name = left(item,len(item)-2)	
			result("\n Installing <"+submenu+">: "+item)
			try 
				{
				AddScriptToPackage(base+item,packageNAME,0,name,menu,submenu, 0)
				}
			catch
				{
				result(" \t ERROR DURING INSTALL")
				}
			}
		i++
		}
	}

